
package de.ivu.elect.presentation.ergebnis;

import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.ergebnis.boundary.ErgebnisNichtAusgewaehltException;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisSelectChangeEvent;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisSessionSelect;
import de.ivu.elect.business.ergebnis.entity.DHondtQuotientPolitischeGruppe;
import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.ergebnis.form.DHondtQuotientSearchFormBuilder;
import de.ivu.elect.presentation.ergebnis.table.DHondtQuotientPolitischeGruppeColumnBuilder;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.security.AbstractGebietSecurityFilter;

@OnlineHilfeId(value = "156", mehrfachVergebenOk = true)
@ViewAccessScoped
@Named(AbstractDHondtQuotientPolitischeGruppeSearchView.COMPONENT_NAME)
@View(viewId = AbstractDHondtQuotientPolitischeGruppeSearchView.VIEW_ID, useCase = UseCasePermission.D_HONDT_QUOTIENT_SEARCH)
public class DHondtQuotientPolitischeGruppeSearchView extends AbstractDHondtQuotientPolitischeGruppeSearchView {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient ErgebnisSessionSelect ergebnisSessionSelect;

  @Inject
  private transient DHondtQuotientSearchFormBuilder dHondtQuotientSearchFormBuilder;

  @Inject
  private transient DHondtQuotientPolitischeGruppeColumnBuilder dHondtQuotientPolitischeGruppeColumnBuilder;

  public DHondtQuotientPolitischeGruppeSearchView() {
    super();
  }

  @PreConditionCheck
  public String checkErgebnisSelected() {
    if (!isErgebnisSelected()) {
      throw new ErgebnisNichtAusgewaehltException();
    }

    return null;
  }

  @Override
  protected AbstractGebietSecurityFilter<DHondtQuotientPolitischeGruppe> getGebietSecurityFilter() {
    return KEIN_GEBIET_SECURITY_FILTER;
  }

  private boolean isErgebnisSelected() {
    return ergebnisSessionSelect.isSelected();
  }

  private Ergebnis getSelectedErgebnis() {
    return ergebnisSessionSelect.getEntity();
  }

  @Override
  public int getDefaultPageSize() {
    return getPageSizeShowAll();
  }

  @Override
  public void addProperties(FormBuilder formBuilder) {
    dHondtQuotientSearchFormBuilder.addProperties(formBuilder, getSelectedErgebnis(), getSelectedGebiet(), getSearchParameters());
  }

  /**
   * @deprecated To be removed...
   * @see DHondtQuotientPolitischeGruppeSearchView#initSearchParametersByContext
   */
  @Deprecated
  @Override
  public void presetSearchParameters() {
    // To be removed...
  }

  @Override
  protected void initSearchParametersByContext() {
    super.initSearchParametersByContext();

    getSearchParameters().setErgebnis(getSelectedErgebnis());
  }

  public void onErgebnisSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) ErgebnisSelectChangeEvent event) {
    reset();
  }

  @Override
  public EagerLoadingCollector<DHondtQuotientPolitischeGruppe> getEagerLoadingCollector() {
    EagerLoadingCollector<DHondtQuotientPolitischeGruppe> eagerLoadingCollector = super.getEagerLoadingCollector();
    dHondtQuotientPolitischeGruppeColumnBuilder.collectEagerLoadings(eagerLoadingCollector);

    return eagerLoadingCollector;
  }
}
